LAD-Boosting on Regression Trees for Pairwise Potentials (Training)
-------------------------------------------------------------------
The set of scripts in train_pairwise_regressor/ can be used to train the 
regressor for generating pairwise potentials. We used BSD-500 for this 
training. Steps:

1. Compile filter_points_major_dir.cpp:
     mex -O filter_points_major_dir.cpp;

2. Get the full BSD-500 package:
  http://www.eecs.berkeley.edu/Research/Projects/CS/vision/grouping/BSR/BSR_full.tgz


3. Set paths in gather_feats.m.
    a. 'bsr_path' should point to where you downloaded BSD-500.
    b. 'fuxin_lib_dir' should point to the fuxin's library src, which 
       should be in prepkgd_extern_src/fuxin_lib_src/

4. Run gather_feats. The first argument should be the mat filepath where you 
   want to save the computed training features. All following arguments are 
   exactly what you give to rigor_obj_segments. Typically you run RIGOR without 
   any parameters: rigor_obj_segments('peppers.png');. If so, you should do the 
   same with gather_feats:
        gather_feats('trainval.mat');
   For instance, if you are using SketchTokens 
   [rigor_obj_segments('peppers.png', 'boundaries_method','SketchTokens')], and
   not the default StructEdges boundary detector, you should run gather_feats 
   like this:
        gather_feats('trainval_ST.mat', 'boundaries_method','SketchTokens');
   This is the slowest step, so get some sleep :)

5. Run pick_high_inds, which picks training samples in a certain proportion. 
   You just need to pass it the file where gather_feats saved results:
        [train_high_ind, val_high_ind] = pick_high_inds('trainval.mat');

6. Run train_lad_and_save, which trains the trees by LAD boosting. You need to 
   pass the file produced by gather_feats, the output from pick_high_inds, and 
   mat filepath where you want to save trained model:
     train_lad_and_save('trainval.mat', train_high_ind, val_high_ind, 'pair_trees.mat');

7. Once you have the trained model, you can place it in trained_models/, and 
   then adjust Segmenter.precompute_pairwise_data_feature() to indicate with 
   what parameters this model would be used.


@authors:     Fuxin Li, Ahmad Humayun
@contact:     ahumayun@cc.gatech.edu
@affiliation: Georgia Institute of Technology
@date:        Fall 2013 - Spring 2015