function [feats, output, feats_extra] = gather_feats_dataset(bsr_path, ...
                                                        dataset, varargin)
    filepattern = fullfile(bsr_path, ['BSDS500/data/%s/' dataset '/']);
    img_names = dir(sprintf([filepattern, '*.jpg'], 'images'));
    img_names = {img_names.name};
    img_names = cellfun(@(x) x(1:end-4),img_names, 'UniformOutput',false);
    feats = cell(numel(img_names),1);
    feats_extra = cell(numel(img_names),1);
    output = cell(numel(img_names),1);
    for i=1:numel(img_names)
        i
        img_filepath = sprintf([filepattern, img_names{i}, '.jpg'], ...
                               'images');
        gt_filepath = sprintf([filepattern, img_names{i}, '.mat'], ...
                              'groundTruth');
        % load GroundTruth
        load(gt_filepath);
        % get boundaries and superpixels (using same method as
        % rigor_obj_segments)
        [bndry_thin, bndry_fat, sp_data] = ...
            get_bndrs_plus_spx(img_filepath, varargin{:});
        [sp_data, val] = prepare_pairwise_data_feature(sp_data, bndry_thin);

        % get only boundaries which match up with one of the GTs
        accP = Gen_GT_superpix_edgestr(sp_data, groundTruth, true);
        
        [feats{i}, ~, output{i}, sel] = gen_sp_feats(sp_data, val, ...
                                                     double(accP));
    %   [~,feats_extra{i}] = gen_sp_extra_feats(sp_seg, I);
    %   feats_extra{i} = feats_extra{i}(sel,:);
    end
end
