function train_lad_and_save(load_filepath, train_high_ind, val_high_ind, ...
                            trees_filepath, num_trees, tree_depth)
% Please see README.md in this directory. Given training/validation
% features and output labels, this function trains regressopm trees by 
% LAD boosting - which can be later used to compute pairwise potentials.
%
% @authors:     Fuxin Li, Ahmad Humayun
% @contact:     ahumayun@cc.gatech.edu
% @affiliation: Georgia Institute of Technology
% @date:        Fall 2013 - Summer 2014

    % set default parameters
    if ~exist('trees_filepath', 'var'), trees_filepath = 'pair_trees.mat'; end
    if ~exist('num_trees', 'var'), num_trees = 93; end
    if ~exist('tree_depth', 'var'), tree_depth = 6; end
    
    load(load_filepath);
    
    % perform LAD boosting
    [err, trees, f0, rho] = ladboost(train_feats(train_high_ind,:), ...
                                     train_out(train_high_ind), ...
                                     val_feats(val_high_ind,:), ...
                                     val_out(val_high_ind), ...
                                     tree_depth, num_trees);
    scaling_type = [];
    scaling = [];
    ranker_name = 'classregtree_fuxin_ladboost';

    save(trees_filepath, ...
         'trees','f0','rho','scaling_type','scaling','ranker_name');
end