function [catg_strs] = dataset_catg_strs(dataset_id, gt_dir)
    catg_strs = {};
    switch dataset_id
        case 'pascalvoc'
            catg_strs = {'aeroplane', 'bicycle', 'bird', 'boat', ...
                         'bottle', 'bus', 'car', 'cat', 'chair', 'cow', ...
                         'diningtable', 'dog', 'horse', 'motorbike', ...
                         'person', 'pottedplant', 'sheep', 'sofa', ...
                         'train', 'tvmonitor'};
        case 'coco2014'
            if ~isempty(gt_dir)
                if ischar(gt_dir)
                    % first add coco MATLAB api to the path
                    coco_root = fileparts(fileparts(gt_dir));
                    addpath(fullfile(coco_root, 'MatlabAPI'));
                    % load coco data
                    gt_dir = CocoApi(gt_dir);
                end
                catg_ids = gt_dir.getCatIds();
                catg_strs = repmat({''}, 1, max(catg_ids));
                strd_catg = gt_dir.loadCats(catg_ids);
                catg_strs(catg_ids) = {strd_catg.name};
            end
        otherwise
            warning('Unknown dataset_id %s', dataset_id)
    end
end
